(function() {
	$.fn.jImgSlider = function (options) {
		var jis = new ImgSlider(this,options);
		jis.imgSlide();
		return this;
	}

	
var ImgSlider = function (e,opt){
	this.element = e,									
	this.defaults = {									
		'width':600,
		'height':450
	},
	this.sid = 0;										
	this.options = $.extend({}, this.defaults, opt);	
}

	
	ImgSlider.prototype = {
	   
	    appendHtml: function() {
	    	var that = this.element;
	    	that.addClass("jImgSlider-window").children().first().addClass("jImgSlider-container");
			var l = that.children().children().length;
			if(l > 1){						
				var arrowHtml = "<div id='jImgSlider-left-arrow'  class='jImgSlider-arrow'></div><div id='jImgSlider-right-arrow' class='jImgSlider-arrow'></div>";
				that.append(arrowHtml);		

				var i = 0;					
				$(".jImgSlider-container").children().each(function(){
						$(this).attr("id","jSlide-item-"+i++);						
					});

				var sltHtml = "<div class='jImgSlider-selector'>";
				for(i = 0;i < l;i++){
					sltHtml += "<span id='jSlide-selector-"+i+"'></span>";
				}
				sltHtml += "</div>";		
				that.append(sltHtml).find(".jImgSlider-selector").children().first().addClass("jImgSlider-selected");
			}
			that.children().first().children().addClass("jImgSlider-items").first().addClass("jImgSlider-active");
	    },

	    
	    fixPosition: function() {
	    	var that = this.element;
	    	var settings=this.options;
	    	that.css({		
	    		"width":settings.width,
	    		"height":settings.height
	    	}).children().first().css({
	    		"width":(settings.width*2),
	    		"height":settings.height
	    	}).children().find(".jImgSlider-items").css({
	    		"left":settings.width
	    	});
	    	that.find("img").css({
	    		"width":settings.width,
	    		"height":settings.height
	    	});
	    	that.find("#jImgSlider-left-arrow").css({
	    		"top":(settings.height/2)-22    		
	    	});
	    	that.find("#jImgSlider-right-arrow").css({
	    		"top":(settings.height/2)-22,
	    		"right":0   		
	    	});
	    	that.find(".jImgSlider-selector").css({
	    		"left":settings.width/2-25*that.find(".jImgSlider-items").length/2
	    	});	    	
	    },

	    
	    eventBind:function() {
	    		
				$(".jImgSlider-container").mouseenter(function (){
					$("#jImgSlider-left-arrow").fadeIn(200);
					$("#jImgSlider-right-arrow").fadeIn(200);
					$(".jImgSlider-selector").fadeIn(200);
				});
				$(".jImgSlider-window").mouseleave(function(){
					$("#jImgSlider-left-arrow").fadeOut(100);
					$("#jImgSlider-right-arrow").fadeOut(100);
					$(".jImgSlider-selector").fadeOut(100);
					}
				);

				
				$(".jImgSlider-arrow").mouseenter(function (){
					$(this).css("background-color","red");
				}).mouseleave(function (){
					$(this).css("background-color","#393939");
				});

				
				$(".jImgSlider-arrow").click(function (event){
					clearTimeout(this.sid);
					sid=setTimeout(function(){
						var now=$(".jImgSlider-active");
						var nowId=now.attr("id");
						var len=now.siblings().length;
						var next;
						if(event.target.id=="jImgSlider-left-arrow"){
							next=now.prev();
							if(("jSlide-item-0")==nowId){
								next=$(".jImgSlider-container div").last();			
							}
							turnLeft(now,next);
						}else{
							next=now.next();
							if(("jSlide-item-"+len)==nowId){
								next=$(".jImgSlider-container div").first();			
							}
							turnRighr(now,next);
						}
					},200);					
				});

				
				function turnLeft (now,next){
					if(!now.is(":animated")){
								now.animate({"left":683},1000).removeClass("jImgSlider-active");
								next.css("left",-683).animate({"left":0},1000).addClass("jImgSlider-active");
								var nextNo=next.attr("id").substr(12);
								changeSeletor(nextNo);
							}
				}

				
				function turnRighr(now,next){
					if(!now.is(":animated")){
								now.animate({"left":-683},1000).removeClass("jImgSlider-active");
								next.css("left",683).animate({"left":0},1000).addClass("jImgSlider-active");
								var nextNo=next.attr("id").substr(12);
								changeSeletor(nextNo);
							}
				}

				
				function changeSeletor (nextNo){
					var now=$(".jImgSlider-selected");
					var next=$("#jSlide-selector-"+nextNo);
					now.removeClass("jImgSlider-selected");
					next.addClass("jImgSlider-selected");
				}

				
				$(".jImgSlider-selector span").click(function (){
					var now=$(".jImgSlider-active");
					var next=$("#jSlide-item-"+$(this).attr("id").substr(16));
					var nowNo=now.attr("id").substr(12);
					var nextNo=next.attr("id").substr(12);
					if(nowNo>nextNo){
						turnLeft(now,next);
					}else{
						turnRighr(now,next);
					}
					changeSeletor(nextNo);					
				});

				
				function autoPlay(){
					setTimeout(function(){
						$("#jImgSlider-right-arrow").trigger("click");
						autoPlay();
					},4000);
				}
				autoPlay();

	    },

	    
	    imgSlide: function() {	    	
	    	this.appendHtml();
	    	this.fixPosition();  
	    	this.eventBind();  	
	    }
	}
})();
